<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:xhtml="http://www.w3.org/1999/xhtml"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:ws="http://www.ebenoit.info/data">

	<xsl:output method="xml"
			omit-xml-declaration="no"
			indent="yes"
			media-type="application/xhtml+xml"
			doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
			doctype-public="-//W3C//DTD XHTML 1.1//EN" />

	<xsl:template match="/">
		<xsl:apply-templates select="/ws:error/ws:error-xhtml/xhtml:html" />
	</xsl:template>

	<xsl:template match="ws:exception-data">
		<xsl:variable name="exc-text" select="ws:text[ @id = 'exc-text' ]" />
		<xsl:variable name="exc-type" select="ws:text[ @id = 'exc-type' ]" />
		<xsl:variable name="exc-file" select="ws:text[ @id = 'exc-file' ]" />
		<xsl:variable name="exc-line" select="ws:text[ @id = 'exc-line' ]" />
		<xsl:variable name="exc-function" select="ws:text[ @id = 'exc-function' ]" />
		<p>
			<strong><xsl:value-of select="$exc-text" /></strong>:
			<xsl:value-of select="/ws:error/ws:exception/ws:text" /><br/>
			<strong><xsl:value-of select="$exc-type" /></strong>:
			<xsl:value-of select="/ws:error/ws:exception/ws:type" /><br/>
		</p>
		<xsl:if test="/ws:error/ws:exception/ws:trace/ws:entry">
			<table style="width:100%">
				<tr>
					<th style="text-align:left"><xsl:value-of select="$exc-file" /></th>
					<th style="text-align:left"><xsl:value-of select="$exc-function" /></th>
					<th style="text-align:left"><xsl:value-of select="$exc-line" /></th>
				</tr>
				<xsl:for-each select="/ws:error/ws:exception/ws:trace/ws:entry">
					<tr>
						<td style="text-align:left"><xsl:value-of select="ws:file" /></td>
						<td style="text-align:left"><xsl:value-of select="ws:function" /></td>
						<td style="text-align:left"><xsl:value-of select="ws:line" /></td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
	</xsl:template>

	<xsl:template match="@*|node()" priority="-5">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
